#include "ad++.h"


int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;

  Procs2 p(2, 2) ;


  ON(p) {
    BlockRange x(2, p.dim(0)) ;
    BlockRange y(2, p.dim(1)) ;

    Array2<float> a(x, y), b(y, x) ;

    Index i(x), j(y) ;
    /*
    OVERALL(i) {
      OVERALL(j) {
        a(i, j) = 10 * (1 + i) + 1 + j ;
      } ALLOVER(j) ;
    } ALLOVER(i) ;
    */
    ascanf("%f", a);
    aprintf("%7.1f%*N", a, x.size()) ;

    Array2<float> tmp1(x, y) ;
    OVERALL(i) {
      OVERALL(j) {
        tmp1(i, j) = a(i, j) + 2 ;
      } ALLOVER(j) ;
    } ALLOVER(i) ;
    aprintf("%7.1f%*N", tmp1, x.size()) ;

    remap(b, tmp1) ;

    aprintf("%7.1f%*N", b, x.size()) ;
  } NO(p) ;

  AdlibFinalize() ;
}
